package  {
	
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.filters.BevelFilter;
	import flash.filters.BlurFilter;
	import flash.text.TextField;
	import flash.text.TextFormat;

	public class Cell extends Sprite {
		
		public var j:int;
		public var i:int;
		public var isOpened:Boolean = false;
		public var isMine:Boolean = false;
		
		private var tf:TextField;
		private var field:Field;
		
		public function Cell(i:int, j:int, field:Field) {
			this.field = field;
			
			this.j = j;
			this.i = i;
			
			x = 16 * i;
			y = 16 * j;
			
			graphics.beginFill(0xCCCCCC);
			graphics.lineStyle(1, 0x777777);
			graphics.drawRect(0, 0, 16, 16);
			graphics.endFill();
			
			drawClosed();
			
			addEventListener(MouseEvent.MOUSE_DOWN, onDown);
			addEventListener(MouseEvent.MOUSE_UP, onUp);
			addEventListener(MouseEvent.ROLL_OUT, onOut);
			addEventListener(MouseEvent.ROLL_OVER, onOver);
		}
		
		private function onOver(e:MouseEvent):void {
			if (e.buttonDown) drawPressed();
		}
		
		private function onOut(e:MouseEvent):void {
			drawClosed();
		}
		
		private function onUp(e:MouseEvent):void {
			dispatchEvent(new Event(Event.OPEN, true));
			open();
		}
		
		public function open():void {
			
			if (isOpened) return;
			
			isOpened = true;
			
			drawOpened();
			
			tf = new TextField();
			tf.width = 13;
			tf.height = 18;
			tf.x = 3;
			addChild(tf);
			
			removeEventListener(MouseEvent.MOUSE_DOWN, onDown);
			removeEventListener(MouseEvent.MOUSE_UP, onUp);
			removeEventListener(MouseEvent.ROLL_OUT, onOut);
			removeEventListener(MouseEvent.ROLL_OVER, onOver);
		
			if (isMine) {
				tf.text = "*";
				return;
			}
			
			var aroundMines:int = field.calculateMines(i, j);
			
			if (aroundMines == 0) {
				field.openAllAround(i,j);
			}else {
				var colors:Array = [
					0x0000FF,
					0x005E00,
					0xFF0000,
					0x000042,
					0x400000,
					0x408080,
					0x000000,
					0x808080
				];
				tf.defaultTextFormat =
				new TextFormat("Arial", 13, colors[aroundMines - 1], true);
				
				tf.text = String(aroundMines);
			}
		}
		
		private function onDown(e:MouseEvent):void {
			drawPressed();
		}
		
		
		private function drawClosed():void {
			filters = [
				new BevelFilter(3, 45, 0xFFFFFF, 1, 0, 0.5, 0, 0)
			];
		}
		
		private function drawOpened():void {
			filters = [ ];
		}
		
		private function drawPressed():void {
			filters = [
				new BevelFilter(3, 45, 0, 1, 0xFFFFFF, 0.5, 0, 0)
			];
		}
		
	}

}